local string = string
local table = table
local Debug = Debug
local Effect = Effect
local Duel = Duel
local Card = Card
local d = {}
local f = {}
d["排_效果卡之类型"] = {
  TYPE_SPELL,
  TYPE_TRAP,
  TYPE_EFFECT,
  }
d["排_非效果灵摆怪兽之卡片编号"] = {
  28363749,
  19474136,
  17390179,
  83980492,
  }
d["数_所有区域"] = LOCATION_HAND + LOCATION_MZONE + LOCATION_SZONE + LOCATION_GRAVE + LOCATION_REMOVED + LOCATION_DECK + LOCATION_EXTRA
do
  --~ 这一局所适用规则的对
  local k1
  k1 = {
    [3] = "大师规则三（2014）　",
    [4] = "新大师规则（2017）　",
    [5] = "大师规则（2020）　",
    }
  f["Debug.ReloadFieldBegin"] = _G.Debug.ReloadFieldBegin
  --~ 数_这一局的模式
  --~ 数_规则参数
  function _G.Debug.ReloadFieldBegin(o1, o2)
    d["数_假洗卡"] = o1 & DUEL_PSEUDO_SHUFFLE
    d["数_战斗阶段"] = o1 & DUEL_ATTACK_FIRST_TURN
    d["数_人工智能"] = o1 & DUEL_SIMPLE_AI
    if o2 then
      d["字_这一局的规则"] = k1[o2]
    else
      d["字_这一局的规则"] = k1[5]
      end
    f["Debug.ReloadFieldBegin"](o1, o2)
    end
  end
f["不被连锁"] = function()
  Duel.SetChainLimit(aux.FALSE)
  return true
  end
f["是否有效果卡"] = function(card)
  for k11 = 1, #d["排_效果卡之类型"] do
    if Card.IsType(card, d["排_效果卡之类型"][k11]) then
      return true
      end
    end
  if Card.IsType(card, TYPE_PENDULUM) then
    for k11 = 1, #d["排_非效果灵摆怪兽之卡片编号"] do
      if Card.IsCode(card, d["排_非效果灵摆怪兽之卡片编号"][k11]) then
        return false
      else
        end
      end
    return true
    end
  end
do
  --~ 量_从卡组选几张卡加入手卡
  local k1
  --~ 效果_所调用这个效果的效果
  --~ 数_所调用这个效果的玩家
  f["_从卡组选卡加入手卡"] = function(o1, o2)
    --~ 卡_玩家选定的卡
    local k2
    k2 = Duel.SelectMatchingCard(o2, Card.IsAbleToHand, o2, LOCATION_DECK, 0, k1, k1, nil)
    Duel.SendtoHand(k2, nil, REASON_RULE)
    o1:Reset()
    end
  --~ 量_从卡组选几张卡加入手卡
  f["从卡组选卡加入手卡"] = function(o1)
    --~ 效果
    local k2
    d["量_从卡组选几张卡加入手卡"] = o1
    k1 = o1
    k2 = Effect.GlobalEffect()
    k2:SetType(EFFECT_TYPE_FIELD + EFFECT_TYPE_CONTINUOUS)
    k2:SetCode(EVENT_ADJUST)
    k2:SetCondition(aux.TRUE)
    k2:SetOperation(f["_从卡组选卡加入手卡"])
    Duel.RegisterEffect(k2, 0)
    end
  end
--~ 量_禁用几个我方主要怪兽区域
f["禁用我方主要怪兽区域"] = function(o1)
  --~ 效果
  local k1
  d["量_禁用几个我方主要怪兽区域"] = o1
  k1 = Effect.GlobalEffect()
  k1:SetCode(EFFECT_USE_EXTRA_MZONE)
  k1:SetValue(o1)
  Duel.RegisterEffect(k1, 0)
  end
do
  --~ 字_印卡过多时的文字提示
  --~ 量_现在的印卡数量
  --~ 量_手卡印卡数量的上限
  --~ 量_印卡总数量的上限
  local k1, k2, k3, k4
  k1 = "印卡过多"
  k2 = 1
  k3 = 0
  k4 = 0
  --~ 效果_所调用这个效果的效果
  --~ 数_所调用这个效果的玩家
  f["_印卡"] = function(o1, o2)
    --~ 数_玩家宣言要印的卡之卡片编号
    --~ 卡
    local k5, k6
    k5 = Duel.AnnounceCard(o2)
    k6 = Duel.CreateToken(o2, k5)
    if k2 <= k3 then
      k2 = k2 + 1
      Duel.SendtoHand(k6, nil, REASON_RULE)
    else
      if k2 <= k4 then
        k2 = k2 + 1
        Duel.SendtoDeck(k6, o2, 0, REASON_RULE)
      else
        Debug.ShowHint(k1)
        o1:Reset()
        end
      end
    end
  --~ 卡_印卡的启动源
  --~ 量_手卡印卡数量的上限
  --~ 量_印卡总数量的上限
  f["印卡"] = function(o1, o2, o3)
    --~ 效果
    local k5
    k3 = o2
    k4 = o3 or o2
    Debug.ShowHint("点击对方额外卡组，可以印卡\n只能印 " .. k3 .. " 张手卡\n最多可印 " .. k4 .. " 张卡")
    k5 = Effect.CreateEffect(o1)
    k5:SetType(EFFECT_TYPE_IGNITION)
    k5:SetProperty(EFFECT_FLAG_BOTH_SIDE + EFFECT_FLAG_UNCOPYABLE + EFFECT_FLAG_CANNOT_DISABLE)
    k5:SetTarget(f["不被连锁"])
    k5:SetRange(LOCATION_EXTRA)
    k5:SetOperation(f["_印卡"])
    o1:RegisterEffect(k5)
    end
  end
f["开局说明"] = function()
  --~ 字_开局说明
  --~ 量_我方的效果卡
  --~ 组_我方超量素材
  --~ 量_对方的效果卡
  --~ 组_对方超量素材
  --~ 量_效果卡
  local k1, k2, k3, k4, k5, k6
  k2 = Duel.GetMatchingGroupCount(f["是否有效果卡"], 0, d["数_所有区域"], nil, nil)
  k3 = Duel.GetOverlayGroup(0, LOCATION_MZONE, nil)
  for o1 in aux.Next(k3) do
    if f["是否有效果卡"](o1) then
      k2 = k2 + 1
      end
    end
  k4 = Duel.GetMatchingGroupCount(f["是否有效果卡"], 0, nil, d["数_所有区域"], nil)
  k5 = Duel.GetOverlayGroup(0, nil, LOCATION_MZONE)
  for o1 in aux.Next(k5) do
    if f["是否有效果卡"](o1) then
      k4 = k4 + 1
      end
    end
  k6 = k2 + k4
  k1 = "" .. k6 .. "卡　" .. k4 .. "卡　" .. d["字_这一局的规则"]
  if d["数_假洗卡"] == 0 then
  else
    k1 = k1 .. "假洗卡　"
    end
  if d["数_战斗阶段"] == 0 then
    k1 = k1 .. "无战斗阶段　"
    end
  if d["数_人工智能"] == 0 then
    k1 = k1 .. "无人工智能　"
    end
  if d["量_从卡组选几张卡加入手卡"] then
    k1 = k1 .. "选" .. d["量_从卡组选几张卡加入手卡"] .. "卡加入手卡　"
    end
  if d["量_禁用几个我方主要怪兽区域"] then
    k1 = k1 .. "禁用" .. d["量_禁用几个我方主要怪兽区域"] .. "个我方主要怪兽区域　"
    end
  Debug.ShowHint(k1)
  end
do
  f["aux.BeginPuzzle"] = _G.aux.BeginPuzzle
  --~ 量_从卡组选几张卡加入手卡
  --~ 量_禁几个我方主要怪兽格
  --~ 卡_传入对方额外卡组最上面的表侧卡，并将其作为印卡源
  --~ 量_能印几张手卡
  --~ 量_最多能印几张卡
  function _G.aux.BeginPuzzle(o1, o2, o3, o4, o5)
    f["aux.BeginPuzzle"]()
    if o1 then
      f["从卡组选卡加入手卡"](o1)
    else
      end
    if o2 then
      f["禁用我方主要怪兽区域"](o2)
    else
      end
    if o3 then
      f["印卡"](o3, o4, o5)
    else
      end
    f["开局说明"]()
    end
  end
Auxiliary.PuzzleOp = function()
  Duel.SetLP(0,0)
  for i = 1, #d["排_局末提示"] do
    Debug.ShowHint(d["排_局末提示"][i])
    end
  end
do
  f["Debug.ReloadFieldEnd"] = _G.Debug.ReloadFieldEnd
  --~ 局末提示
  function _G.Debug.ReloadFieldEnd(...)
    f["Debug.ReloadFieldEnd"]()
    d["排_局末提示"] = {...}
    end
  end
